searchNodes=[{"doc":"Freedom Formatter is a fork of Elixir's code formatter, with added freedom. It respects .formatter.exs and supports all features of the standard code formatter, as well as additional features unlikely to arrive soon in core Elixir. Usage Install: { :freedom_formatter , &quot;~&gt; 1.0&quot; , only : :dev } Run: mix fformat Why Elixir's code formatter does not intend to support trailing commas, or indeed any additional settings, until at least January 2019. See Elixir issues #7689 and #6646 for more information. Thanks to software freedom, we can use tomorrow's formatter today. Project Goals To provide a compatible alternative to the Elixir formatter, available separately from the core Elixir distribution To allow developers and teams to benefit from standardized code formatting while retaining a style they find more productive To be a testbed for new formatting features and options, maintaining the easiest possible path to possible inclusion in core Elixir. Added features Freedom Formatter supports all Elixir's standard code formatting options, as well as: :trailing_comma - if set true , multi-line list, map, and struct literals will include a trailing comma after the last item or pair in the data structure. Does not affect argument lists, tuples, or lists/maps/structs rendered on a single line. Thanks Thanks to José Valim for hacking together a code formatter and getting it almost perfect. :)","ref":"FreedomFormatter.html","title":"FreedomFormatter","type":"module"},{"doc":"Formats a file. See format_string!/2 for more information on code formatting and available options.","ref":"FreedomFormatter.html#format_file!/2","title":"FreedomFormatter.format_file!/2","type":"function"},{"doc":"See Code.format_string!/2","ref":"FreedomFormatter.html#format_string!/2","title":"FreedomFormatter.format_string!/2","type":"function"},{"doc":"Formats the given files and patterns. mix fformat mix . exs &quot;lib/**/*.{ex,exs}&quot; &quot;test/**/*.{ex,exs}&quot; If any of the files is - , then the output is read from stdin and written to stdout. Formatting options The formatter will read a .formatter.exs file in the current directory for formatter configuration. Evaluating this file should return a keyword list. Here is an example of a .formatter.exs file that works as a starting point: [ inputs : [ &quot;{mix,.formatter}.exs&quot; , &quot;{config,lib,test}/**/*.{ex,exs}&quot; ] ] Besides the options listed in Code.format_string!/2 , the .formatter.exs file supports the following options: :inputs (a list of paths and patterns) - specifies the default inputs to be used by this task. For example, [&quot;mix.exs&quot;, &quot;{config,lib,test}/**/*.{ex,exs}&quot;] . Patterns are expanded with Path.wildcard/2 . :plugins (a list of modules) (since v1.13.0) - specifies a list of modules to customize how the formatter works. See the &quot;Plugins&quot; section below for more information. :subdirectories (a list of paths and patterns) - specifies subdirectories that have their own formatting rules. Each subdirectory should have a .formatter.exs that configures how entries in that subdirectory should be formatted as. Configuration between .formatter.exs are not shared nor inherited. If a .formatter.exs lists &quot;lib/app&quot; as a subdirectory, the rules in .formatter.exs won't be available in lib/app/.formatter.exs . Note that the parent .formatter.exs must not specify files inside the &quot;lib/app&quot; subdirectory in its :inputs configuration. If this happens, the behaviour of which formatter configuration will be picked is unspecified. :import_deps (a list of dependencies as atoms) - specifies a list of dependencies whose formatter configuration will be imported. See the &quot;Importing dependencies configuration&quot; section below for more information. :export (a keyword list) - specifies formatter configuration to be exported. See the &quot;Importing dependencies configuration&quot; section below. Task-specific options --check-formatted - checks that the file is already formatted. This is useful in pre-commit hooks and CI scripts if you want to reject contributions with unformatted code. If the check fails, the formatted contents are not written to disk. Keep in mind that the formatted output may differ between Elixir versions as improvements and fixes are applied to the formatter. --dry-run - does not save files after formatting. --dot-formatter - path to the file with formatter configuration. Defaults to .formatter.exs if one is available. See the &quot;Formatting options&quot; section above for more information. When to format code We recommend developers to format code directly in their editors, either automatically when saving a file or via an explicit command or key binding. If such option is not available in your editor of choice, adding the required integration is usually a matter of invoking: cd $ project &amp;&amp; mix fformat $ file where $file refers to the current file and $project is the root of your project. It is also possible to format code across the whole project by passing a list of patterns and files to mix fformat , as shown at the top of this task documentation. This list can also be set in the .formatter.exs file under the :inputs key. Plugins It is possible to customize how the formatter behaves. Plugins must implement the Mix.Tasks.Fformat behaviour. For example, imagine that your project uses Markdown in two distinct ways: via a custom ~M sigil and via files with the .md and .markdown extensions. A custom plugin would look like this: defmodule MixMarkdownFormatter do @behaviour Mix.Tasks.Fformat def features ( _opts ) do [ sigils : [ :M ] , extensions : [ &quot;.md&quot; , &quot;.markdown&quot; ] ] end def format ( contents , opts ) do # logic that formats markdown end end The opts passed to format/2 contains all the formatting options and either: * ` :sigil ` ( atom ) - the sigil being formatted , e . g . ` :M ` . * ` :modifiers ` ( charlist ) - list of sigil modifiers . * ` :extension ` ( string ) - the extension of the file being formatted , e . g . ` &quot;.md&quot; ` . Now any application can use your formatter as follows: # .formatters.exs [ # Define the desired plugins plugins : [ MixMarkdownFormatter ] , # Remember to update the inputs list to include the new extensions inputs : [ &quot;{mix,.formatter}.exs&quot; , &quot;{config,lib,test}/**/*.{ex,exs}&quot; , &quot;posts/*.{md,markdown}&quot; ] ] Remember that, when running the formatter with plugins, you must make sure that your dependencies and your application have been compiled, so the relevant plugin code can be loaded. Otherwise a warning is logged. Importing dependencies configuration This task supports importing formatter configuration from dependencies. A dependency that wants to export formatter configuration needs to have a .formatter.exs file at the root of the project. In this file, the dependency can list an :export option with configuration to export. For now, only one option is supported under :export : :locals_without_parens (whose value has the same shape as the value of the :locals_without_parens in Code.format_string!/2 ). The functions listed under :locals_without_parens in the :export option of a dependency can be imported in a project by listing that dependency in the :import_deps option of the formatter configuration file of the project. For example, consider you have a project called my_app that depends on another one called my_dep . my_dep wants to export some configuration, so my_dep/.formatter.exs would look like this: # my_dep/.formatter.exs [ # Regular formatter configuration for my_dep # ... export : [ locals_without_parens : [ some_dsl_call : 2 , some_dsl_call : 3 ] ] ] In order to import configuration, my_app 's .formatter.exs would look like this: # my_app/.formatter.exs [ import_deps : [ :my_dep ] ]","ref":"Mix.Tasks.Fformat.html","title":"Mix.Tasks.Fformat","type":"behaviour"},{"doc":"Returns which features this plugin should plug into.","ref":"Mix.Tasks.Fformat.html#c:features/1","title":"Mix.Tasks.Fformat.features/1","type":"callback"},{"doc":"Receives a string to be formatted with options and returns said string.","ref":"Mix.Tasks.Fformat.html#c:format/2","title":"Mix.Tasks.Fformat.format/2","type":"callback"},{"doc":"Returns a formatter function and the formatter options to be used for the given file. The function must be called with the contents of the file to be formatted. The options are returned for reflection purposes.","ref":"Mix.Tasks.Fformat.html#formatter_for_file/2","title":"Mix.Tasks.Fformat.formatter_for_file/2","type":"function"},{"doc":"Returns formatter options to be used for the given file.","ref":"Mix.Tasks.Fformat.html#formatter_opts_for_file/2","title":"Mix.Tasks.Fformat.formatter_opts_for_file/2","type":"function"}]